"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createStore;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _mapGetWithDefault = _interopRequireDefault(require("@postinumero/map-get-with-default"));

function createStore() {
  var root = {
    children: new Map()
  };
  return function (path, create) {
    function remove(_ref) {
      var onCleanup = _ref.onCleanup,
          value = _ref.value,
          parent = _ref.parent;
      onCleanup === null || onCleanup === void 0 ? void 0 : onCleanup(value);

      (function removeChild(path, _ref2) {
        var parent = _ref2.parent,
            children = _ref2.children;
        children.delete(path.pop());

        if (!children.size) {
          removeChild(path, parent);
        }
      })((0, _toConsumableArray2.default)(path), parent);
    }

    var item = path.reduce(function (parent, key) {
      var _context;

      return (_context = parent.children, _mapGetWithDefault.default).call(_context, key, function () {
        var _create = create(function () {
          return remove(item);
        }),
            _create2 = (0, _slicedToArray2.default)(_create, 2),
            value = _create2[0],
            onCleanup = _create2[1];

        var item = {
          value: value,
          onCleanup: onCleanup,
          parent: parent,
          referenceCounter: 0,
          children: new Map()
        };
        return item;
      });
    }, root);
    item.referenceCounter = item.referenceCounter + 1;
    return [item.value, function cleanup() {
      item.referenceCounter = item.referenceCounter - 1;

      if (!item.referenceCounter) {
        remove(item);
      }
    }];
  };
}
//# sourceMappingURL=createStore.js.map