"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createSubscription;

function createSubscription(_subscribe, remove) {
  var value;
  var unsubscribe;
  var updaters = new Set();
  return {
    getCurrentValue: function getCurrentValue() {
      return value;
    },
    subscribe: function subscribe(update) {
      if (!updaters.size) {
        unsubscribe = _subscribe(function (nextValue) {
          value = [null, nextValue];
          updaters.forEach(function (updater) {
            return updater();
          });
        });
      }

      updaters.add(update);
      return function () {
        updaters.delete(update);

        if (!updaters.size) {
          var _unsubscribe;

          remove();
          (_unsubscribe = unsubscribe) === null || _unsubscribe === void 0 ? void 0 : _unsubscribe();
        }
      };
    }
  };
}
//# sourceMappingURL=createSubscription.js.map