import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import get from '@postinumero/map-get-with-default';
export default function createStore() {
  var root = {
    children: new Map()
  };
  return function (path, create) {
    function remove(_ref) {
      var onCleanup = _ref.onCleanup,
          value = _ref.value,
          parent = _ref.parent;
      onCleanup === null || onCleanup === void 0 ? void 0 : onCleanup(value);

      (function removeChild(path, _ref2) {
        var parent = _ref2.parent,
            children = _ref2.children;
        children.delete(path.pop());

        if (!children.size) {
          removeChild(path, parent);
        }
      })(_toConsumableArray(path), parent);
    }

    var item = path.reduce(function (parent, key) {
      var _context;

      return (_context = parent.children, get).call(_context, key, function () {
        var _create = create(function () {
          return remove(item);
        }),
            _create2 = _slicedToArray(_create, 2),
            value = _create2[0],
            onCleanup = _create2[1];

        var item = {
          value: value,
          onCleanup: onCleanup,
          parent: parent,
          referenceCounter: 0,
          children: new Map()
        };
        return item;
      });
    }, root);
    item.referenceCounter = item.referenceCounter + 1;
    return [item.value, function cleanup() {
      item.referenceCounter = item.referenceCounter - 1;

      if (!item.referenceCounter) {
        remove(item);
      }
    }];
  };
}
//# sourceMappingURL=createStore.js.map