"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useSuspenseContextCleanupHandlers;

var _react = _interopRequireWildcard(require("react"));

var Suspense = _react.default.Suspense;
var Context = (0, _react.createContext)(); // Dangerously overwrite React.Suspense.
// Wrap original Suspense with a context provider.
// Context value is a set of callbacks.
// Each callback is invoked when Suspense component unmounts.

_react.default.Suspense = function ReactPouchDBSuspenseCleanupContext(props) {
  var handlers = (0, _react.useMemo)(function () {
    return new Set();
  }, []);
  (0, _react.useEffect)(function () {
    return function () {
      return handlers.forEach(function (handler) {
        return handler();
      });
    };
  }, []);
  return _react.default.createElement(Context.Provider, {
    value: handlers
  }, _react.default.createElement(Suspense, props));
};

function useSuspenseContextCleanupHandlers() {
  return (0, _react.useContext)(Context);
}
//# sourceMappingURL=useSuspenseContextCleanupHandlers.js.map